* Program..:  Findoffs.PRG  
* Author...:  Kenneth N. Getz  
* Date.....:  January 1, 1988  
* Notes....:  Findoffs.PRG finds the offset within a record for the given  
*             field.  You call Findoffs with the command line:  
*  
*                offset = 0  
*                DO Findoffs WITH "<filename>", "<fieldname>", offset  
*                  
*             The memory variable "offset" will hold the correct numeric  
*             value upon return.  
*               
*             If an error occurs, Findoffs will return one of the following   
*             error codes in the variable offset:  
*  
*                -1 : Database file not found.  
*                -2 : Fieldname not found within database file.  
*  
PARAMETERS filename, fieldname, offset  
*  
*  
* ---Initialize the necessary variables.  
filename  = TRIM(filename)  
fieldname = UPPER(TRIM(fieldname))  
offset    = 0  
*  
* ---If the file exists, use it, otherwise return an error.  
IF FILE("&filename..DBF")
   USE &filename  
ELSE
   offset = -1
   RETURN  
ENDIF  
*  
* ---Build a structure extended file and USE it.  
COPY STRUCTURE EXTENDED TO &filename..EXT  
USE &filename..EXT  
*  
* ---Add up the field lengths ahead of the field in question.  
DO WHILE Field_name <> fieldname .AND. .NOT. EOF()
   offset = offset + Field_len
   SKIP  
ENDDO  
USE  
ERASE &filename..EXT  
*  
* ---If the field is not found, return an error.  
IF EOF()     
   offset = -2  
ENDIF  
* EOP Findoffs.PRG

